



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>QEMU KVM libvirt手册(2): monitor</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">QEMU KVM libvirt手册(2): monitor</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 15:31:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>Administrating Virtual Machines with QEMU Monitor</h1>
<p>When QEMU is running, a monitor console is provided for performing interaction with the user. Using the commands available in the monitor console, it is possible to inspect the running operating system, change removable media, take screen shots or audio grabs and control several other aspects of the virtual machine.</p>
<h2>Accessing Monitor Console</h2>
<p>To access the monitor console from QEMU, press Ctrl+Alt+2. To return back to QEMU from the monitor console, press Ctrl+Alt+1.</p>
<p>To get help while using the console, use help or ?. To get help for a specific command, use help command.</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/635909/201406/272014251794541.png" /></p>
<h2>Getting Information about the Guest System</h2>
<p>To get information about the guest system, use the info option command. If used without any option, the list of possible options is printed. Options determine which part of the system will be analyzed:</p>
<dl>
<dt>info version</dt>
<dd>
<p>Shows the version of QEMU</p>
</dd>
<dt>info commands</dt>
<dd>
<p>Lists available QMP commands</p>
</dd>
<dt>info network</dt>
<dd>
<p>Shows the network state</p>
</dd>
<dt>info chardev</dt>
<dd>
<p>Shows the character devices</p>
</dd>
<dt>info block</dt>
<dd>
<p>Information about block devices, such as hard drives, floppy drives, or CD-ROMs</p>
</dd>
</dl>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/635909/201406/272014262421499.png" /></p>
<p>info blockstatsRead and write statistics on block devices</p>
<p>info registersShows the CPU registers</p>
<p>info cpusShows information about available CPUs</p>
<p>info historyShows the command line history</p>
<p>info irqShows the interrupts statistics</p>
<p>info picShows the i8259 (PIC) state</p>
<p>info pciShows the PCI information</p>
<p>info tlbShows virtual to physical memory mappings</p>
<p>info memShows the active virtual memory mappings</p>
<p>info jitShows dynamic compiler information</p>
<p>info kvmShows the KVM information</p>
<p>info numaShows the NUMA information</p>
<p>info usbShows the guest USB devices</p>
<p>info usbhostShows the host USB devices</p>
<p>info profileShows the profiling information</p>
<p>info captureShows the capture (audio grab) information</p>
<p>info snapshotsShows the currently saved virtual machine snapshots</p>
<p>info statusShows the current virtual machine status</p>
<p>info pcmciaShows the guest PCMCIA status</p>
<p>info miceShows which guest mice is receiving events</p>
<p>info vncShows the VNC server status</p>
<p>info nameShows the current virtual machine name</p>
<p>info uuidShows the current virtual machine UUID</p>
<p>info usernetShows the user network stack connection states</p>
<p>info migrateShows the migration status</p>
<p>info balloonShows the balloon device information</p>
<p>info qtreeShows the device tree</p>
<p>info qdmShows the qdev device model list</p>
<p>info romsShows the ROMs</p>
<p>info migrate_cache_sizesShows the current migration xbzrle (=Xor Based Zero Run Length Encoding) cache size.</p>
<p>info migrate_capabilitiesShows the status of the various migration capabilities, such as xbzrle compression.</p>
<p>info mtreeShows the VM Guest memory hierarchy.</p>
<p>info trace-events</p>
<p>Shows available trace-events and their status.</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/635909/201406/272014271644413.png" /></p>
<p>这些都可以在VNCViewer里面运行，然而有时候屏幕太小，不全，可以使用virsh进行操作</p>
<p>virsh # list<br />Id&nbsp;&nbsp;&nbsp; Name&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; State<br />----------------------------------------------------<br />14&nbsp;&nbsp;&nbsp; instance-00000009&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; running<br />15&nbsp;&nbsp;&nbsp; instance-0000000a&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; running</p>
<p>virsh # qemu-monitor-command 14 --hmp "info kvm"<br />kvm support: enabled</p>
<p>virsh # qemu-monitor-command 14 --hmp "info blockstats"<br />drive-virtio-disk0: rd_bytes=274441728 wr_bytes=777724928 rd_operations=15528 wr_operations=6520 flush_operations=673 wr_total_time_ns=121355399653 rd_total_time_ns=18996983203 flush_total_time_ns=4363807221</p>
<p>virsh # qemu-monitor-command 14 --hmp "info registers" <br />RAX=0000000000000000 RBX=ffffffff81c01fd8 RCX=00000000ffffffff RDX=0000000000000000<br />RSI=0000000000000001 RDI=ffffffff81ddae48 RBP=ffffffff81c01ea8 RSP=ffffffff81c01ea8<br />R8 =0000000000000000 R9 =0000000000000000 R10=0000000000000000 R11=0000000000000001<br />R12=ffffffff81cdc7c0 R13=0000000000000000 R14=ffffffffffffffff R15=000000000008c800<br />RIP=ffffffff8103df56 RFL=00000246 [---Z-P-] CPL=0 II=0 A20=1 SMM=0 HLT=1<br />ES =0000 0000000000000000 000fffff 00000000<br />CS =0010 0000000000000000 ffffffff 00a09b00 DPL=0 CS64 [-RA]<br />SS =0018 0000000000000000 ffffffff 00c09300 DPL=0 DS&nbsp;&nbsp; [-WA]<br />DS =0000 0000000000000000 000fffff 00000000<br />FS =0000 0000000000000000 ffffffff 00000000<br />GS =0000 ffff88007fc00000 000fffff 00000000<br />LDT=0000 0000000000000000 000fffff 00000000<br />TR =0040 ffff88007fc112c0 00002087 00008b00 DPL=0 TSS64-busy<br />GDT=&nbsp;&nbsp;&nbsp;&nbsp; ffff88007fc04000 0000007f<br />IDT=&nbsp;&nbsp;&nbsp;&nbsp; ffffffff81dd7000 00000fff<br />CR0=8005003b CR2=00007fff4cf57000 CR3=000000007b7fa000 CR4=001406f0<br />DR0=0000000000000000 DR1=0000000000000000 DR2=0000000000000000 DR3=0000000000000000 <br />DR6=00000000ffff0ff0 DR7=0000000000000400<br />EFER=0000000000000d01<br />FCW=037f FSW=0000 [ST=0] FTW=00 MXCSR=00001f80<br />FPR0=0000000000000000 0000 FPR1=0000000000000000 0000<br />FPR2=0000000000000000 0000 FPR3=0000000000000000 0000<br />FPR4=0000000000000000 0000 FPR5=0000000000000000 0000<br />FPR6=0000000000000000 0000 FPR7=0000000000000000 0000<br />XMM00=ffffffff00000000ffffffffff000000 XMM01=00000000000000000000000000ffffff<br />XMM02=00000000000000000000000000435455 XMM03=000000ff000000000000000000ff0000<br />XMM04=40404040404040404040404040404040 XMM05=5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a<br />XMM06=20202020202020202020202020202020 XMM07=ffff00ffffff00ffffffff00ffffffff<br />XMM08=00200000002000000000000000000000 XMM09=ff00ff00000000000000000000000000<br />XMM10=00002000000000000000000000000000 XMM11=00000000000000000000000000000000<br />XMM12=00000000000000000000000000000000 XMM13=00000000000000000000000000000000<br />XMM14=00000000000000000000000000000000 XMM15=00000000000000000000000000000000</p>
<p>virsh # qemu-monitor-command 14 --hmp "info tlb"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <br />0000000000400000: 0000000075a3f000 ----A--U-<br />0000000000401000: 0000000075a3e000 ----A--U-<br />0000000000402000: 00000000759ff000 ----A--U-<br />0000000000403000: 00000000759fe000 ----A--U-<br />0000000000404000: 0000000074dfe000 ----A--U-<br />0000000000405000: 0000000074dbf000 ----A--U-<br />0000000000406000: 0000000074dbe000 ----A--U-<br />0000000000407000: 0000000074d7f000 ----A--U-<br />0000000000408000: 0000000074dff000 ----A--U-<br />0000000000409000: 0000000074e3e000 ----A--U-<br />000000000040a000: 0000000074e3f000 ----A--U-<br />000000000040b000: 0000000074e7e000 ----A--U-<br />000000000040c000: 0000000074e7f000 ----A--U-<br />000000000040d000: 0000000074ebe000 ----A--U-<br />000000000040e000: 0000000074ebf000 ----A--U-</p>
<p>virsh # qemu-monitor-command 14 --hmp "info mem"<br />0000000000400000-0000000000420000 0000000000020000 ur-<br />0000000000421000-0000000000426000 0000000000005000 ur-<br />0000000000427000-000000000042c000 0000000000005000 ur-<br />000000000042e000-000000000044c000 000000000001e000 ur-<br />0000000000656000-0000000000658000 0000000000002000 ur-<br />0000000000658000-000000000065b000 0000000000003000 urw<br />000000000065b000-000000000065d000 0000000000002000 ur-<br />000000000065d000-000000000065f000 0000000000002000 urw<br />00000000006e1000-00000000006e3000 0000000000002000 urw<br />00000000006e3000-00000000006e5000 0000000000002000 ur-<br />00000000006e5000-00000000006e8000 0000000000003000 urw<br />00000000006e8000-00000000006e9000 0000000000001000 ur-<br />00000000006e9000-00000000006ea000 0000000000001000 urw<br />00000000006ea000-00000000006eb000 0000000000001000 ur-<br />00000000006eb000-0000000000701000 0000000000016000 urw<br />0000000000712000-0000000000715000 0000000000003000 urw<br />00007f0a00000000-00007f0a0003c000 000000000003c000 urw<br />00007f0a04000000-00007f0a04004000 0000000000004000 urw<br />00007f0a08000000-00007f0a08002000 0000000000002000 urw<br />00007f0a0e8ea000-00007f0a0e8ec000 0000000000002000 urw<br />00007f0a0f0e2000-00007f0a0f0e3000 0000000000001000 urw<br />00007f0a0f0ea000-00007f0a0f0ed000 0000000000003000 urw<br />00007f0a0f8ea000-00007f0a0f8ee000 0000000000004000 urw<br />00007f0a0f8ee000-00007f0a0f8f1000 0000000000003000 ur-</p>
<p>virsh # qemu-monitor-command 14 --hmp "info balloon"<br />balloon: actual=2048</p>
<h2>Changing VNC Password</h2>
<p>To change the VNC password, use the change vnc password command and enter the new password:</p>
<pre class="prettyprint linenums">(qemu) change vnc password<br />
Password: ********<br />
(qemu)
</pre>
<pre class="prettyprint linenums"><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/635909/201406/272014282114599.png" /> </pre>
<h2>Managing Devices</h2>
<p>To release the device or file connected to the removable media device, use the eject device command. Use the optional -f to force ejection.</p>
<p>To change removable media (like CD-ROMs), use the change device command. The name of the removable media can be determined using the info block command:</p>
<pre class="prettyprint linenums">(qemu) info block<br />
ide1-cd0: type=cdrom removable=1 locked=0 file=/dev/sr0 ro=1 drv=host_device<br />
(qemu) change ide1-cd0 /path/to/image</pre>
<h2>Changing Available Memory</h2>
<p>If the virtual machine was started with the -balloon virtio option and the paravirtualized balloon device that allows to dynamically change the amount of memory available is therefore enabled, it is possible to change the available memory dynamically. For more information about enabling the balloon device.</p>
<p>To get information about the balloon device in the monitor console and to determine whether the device is enabled, use the info balloon command:</p>
<pre class="prettyprint linenums">(qemu) info balloon</pre>
<p>If the balloon device is enabled, use the balloon memory_in_MB command to set the requested amount of memory:</p>
<pre class="prettyprint linenums">(qemu) balloon 400</pre>
<p>virsh # qemu-monitor-command 14 --hmp "info balloon"<br />balloon: actual=2048</p>
<h2>Dumping Virtual Machine Memory</h2>
<p>To save the content of the virtual machine memory to a disk or console output, use the following commands:</p>
<dl>
<dt>memsave addr size filename</dt>
<dd>
<p>Saves virtual memory dump starting at addr of size size to file filename</p>
</dd>
<dt>pmemsave addr size filename</dt>
<dd>
<p>Saves physical memory dump starting at addr of size size to file filename</p>
</dd>
</dl>
<p>filename保存在HOST机器上</p>
<p>addr最小是0000000000400000</p>
<h2>Managing Virtual Machine Snapshots</h2>
<p>Virtual machine snapshots are snapshots of the complete virtual machine including the state of CPU, RAM, and the content of all writable disks. To use virtual machine snapshots, you must have at least one non-removable and writable block device using the qcow2 disk image format.</p>
<p>The following commands are available for managing snapshots in QEMU monitor:</p>
<dl>
<dt>savevm name</dt>
<dd>
<p>Creates a new virtual machine snapshot under the tag name or replaces an existing snapshot.</p>
</dd>
<dt>loadvm name</dt>
<dd>
<p>Loads a virtual machine snapshot tagged name.</p>
</dd>
<dt>delvm</dt>
<dd>
<p>Deletes a virtual machine snapshot.</p>
</dd>
<dt>info snapshots</dt>
<dd>
<p>Prints information about available snapshots.</p>
<pre class="prettyprint linenums">(qemu) info snapshots<br />
Snapshot list:<br />
ID        TAG                    VM SIZE         DATE       VM CLOCK<br />
1         booting                4.4M 2010-11-22 10:51:10   00:00:20.476<br />
2         booted                 184M 2010-11-22 10:53:03   00:02:05.394<br />
3         logged_in              273M 2010-11-22 11:00:25   00:04:34.843<br />
4         ff_and_term_running    372M 2010-11-22 11:12:27   00:08:44.965</pre>
<p>Unique identification number of the snapshot. Usually auto-incremented.</p>
<p>Unique description string of the snapshot. It is meant as a human readable version of the ID.</p>
<p>The disk space occupied by the snapshot. Note that the more memory is consumed by running applications, the bigger the snapshot is.</p>
<p>Time and date the snapshot was created.</p>
<p>The current state of the virtual machine's clock.</p>
</dd>
</dl>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/635909/201406/272014287582401.png" /></p>
<h2>Suspending and Resuming Virtual Machine Execution</h2>
<p>The following commands are available for suspending and resuming virtual machines:</p>
<dl>
<dt>stop</dt>
<dd>
<p>Suspends the execution of the virtual machine.</p>
</dd>
<dt>cont</dt>
<dd>
<p>Resumes the execution of the virtual machine.</p>
</dd>
<dt>system_powerdown</dt>
<dd>
<p>Sends an ACPI shutdown request to the machine. The effect is similar to the power button on a physical machine.</p>
</dd>
<dt>q or quit</dt>
<dd>
<p>Terminates QEMU immediately.</p>
</dd>
</dl>
<h2>Live Migration</h2>
<p>The live migration process allows to transmit any virtual machine from one host system to another host system without any interruption in availability. It is possible to change hosts permanently or just during a maintenance. It is recommended that the source and destination systems have the same architecture, however it is possible to migrate between hosts with AMD and Intel architectures.</p>
<p>The requirements for the live migration:</p>
<ul><li><p>Live migration is only possible between VM Host Servers with the same CPU features. The only supported CPU model for migration is -cpu qemu64 (default) with no additional features specified.</p></li>
<li><p>No physical devices can be passed from host to guest.</p></li>
<li><p>The VM Host Server and VM Guest need to have proper timekeeping installed.</p></li>
<li><p>AHCI interface, virtfs feature, and the -mem-path command-line option are not compatible with migration.</p></li>
<li><p>Migration from SP3 to SP2 or SP1 hosted guests is not supported.</p></li>
<li><p>The virtual machine image must be accessible on both source and destination hosts. For example, it can be located on a shared NFS disk.</p></li>
<li><p>The image directory should be located in the same path on both hosts.</p></li>
<li><p>Both hosts must be located in the same subnet.</p></li>
<li><p>The guest on the source and destination hosts must be started in the same way.</p></li></ul>
<p>The live migration process has the following steps:</p>
<ol><li><p>The virtual machine instance is running on the source host.</p></li>
<li><p>The virtual machine is started on the destination host in the frozen listening mode. The parameters used are the same as on the source host plus the -incoming tcp:ip:port parameter, where ip specifies the IP address and port specifies the port for listening to the incoming migration. If 0 is set as IP address, the virtual machine listens on all interfaces.</p></li>
<li><p>On the source host, switch to the monitor console and use the migrate -d tcp:destination_ip:port command to initiate the migration.</p></li>
<li><p>To determine the state of the migration, use the info migrate command in the monitor console on the source host.</p></li>
<li><p>To cancel the migration, use the migrate_cancel command in the monitor console on the source host.</p></li>
<li><p>To set the maximum tolerable downtime for migration in seconds, use the migrate_set_downtime number_of_seconds command.</p></li>
<li><p>To set the maximum speed for migration in bytes per second, use the migrate_set_speed bytes_per_second command.</p></li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2kzw3q.html">js小数点失精算法修正</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw5rkkq.html">Unity 延迟执行一段代码的较为优雅的方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw44wz8.html">再一个客户端设置多个git账号</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv3gkx8.html">JavaScript学习12 JS中定义对象的几种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4ovpj8.html">StringGrid  实例2：1、获取 StringGrid 的行数、列数&semi; 2、给单元赋值&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zwkpx8.html">cmd命令生成android签名证书</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx7n5j9.html">Java魔法堂：String&period;format详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xwjng9.html">Javascript跨域问题解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m2n3kq.html">NGUI的原理机制：深入剖析UIPanel&comma;UIWidget&comma;UIDrawCall底层原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd6wnd9.html">PAT-L3-球队&OpenCurlyDoubleQuote;食物链&rdquo;-dfs-状压-set</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geyd6e8.html">Socket网络编程详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1jkzmq.html">关于 JavaScript 中的复制数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ke4zz9.html">jforum（1）--环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjp3e79.html">C语言在宏定义中使用语句表达式和预处理器运算符</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv20y0y9.html">【前端基础系列】理解bind方法使用与实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwrdxz9.html">oracle数据库分页总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pweolk8.html">使用pygal&lowbar;maps&lowbar;world&period;i18n中数据画各大洲地图</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em35mk9.html">【学习笔记】--- 老男孩学Python，day18 面向对象------继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjvwjo8.html">EXCEPTION-IBATIS</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1gknx9.html">Spring bean - scope详解</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8m2ez1oq.html">Python开发【第九篇】：进程、线程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rknp58.html">&lbrack;剑指Offer&rsqb;10-斐波那契数列&lpar;循环&rpar;-Java</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwp1xv9.html">SpringCloud微服务负载均衡与网关</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwpv009.html">Ocelot的学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjpz7j9.html">maven项目引用时，导入类报错，选择两个项目同时执行Maven update</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjevw49.html">Vue中观察者模式的实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjpemr9.html">docker run命令运行以及参数详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1z3o49.html">密码与安全新技术专题之AI与密码</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ozk2k8.html">STC项目风险分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5gvm4q.html">sqlserver 并行度</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
